: Class Clip

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.media.j3d
Class Clip

    java.lang.Object
      |
      +--javax.media.j3d.SceneGraphObject
            |
            +--javax.media.j3d.Node
                  |
                  +--javax.media.j3d.Leaf
                        |
                        +--javax.media.j3d.Clip

public class Clip
extends Leaf

The Clip leaf node defines the back, or far, clip distance in the virtual universe. The distance is specified in the local coordinate system of this node. The front clip distance is defined in the View object. If no clip node is in scope of the view platform associated with the current view, then the back clip distance is also defined by the View.

See Also:
  `View`

Field Summary
`static int` | `ALLOW_APPLICATION_BOUNDS_READ` Specifies that the Clip allows read access to its application bounds and bounds leaf at runtime.
`static int` | `ALLOW_APPLICATION_BOUNDS_WRITE` Specifies that the Clip allows write access to its application bounds and bounds leaf at runtime.
`static int` | `ALLOW_BACK_DISTANCE_READ` Specifies that the Clip allows read access to its back distance at runtime.
`static int` | `ALLOW_BACK_DISTANCE_WRITE` Specifies that the Clip allows write access to its back distance at runtime.

Fields inherited from class javax.media.j3d.Node
`ALLOW_AUTO_COMPUTE_BOUNDS_READ, ALLOW_AUTO_COMPUTE_BOUNDS_WRITE, ALLOW_BOUNDS_READ, ALLOW_BOUNDS_WRITE, ALLOW_COLLIDABLE_READ, ALLOW_COLLIDABLE_WRITE, ALLOW_LOCAL_TO_VWORLD_READ, ALLOW_PICK, ALLOW_PICKABLE_READ, ALLOW_PICKABLE_WRITE, ENABLE_COLLISION_REPORTING, ENABLE_PICK_REPORTING`

Constructor Summary
`Clip()` Constructs a Clip node with default parameters.
`Clip(double backDistance)` Constructs a Clip node with the specified back clip distance.

Method Summary
`Node` | `cloneNode(boolean forceDuplicate)` Used to create a new instance of the node.
`void` | `duplicateNode(Node originalNode, boolean forceDuplicate)` Copies all node information from `originalNode` into the current node.
`BoundingLeaf` | `getApplicationBoundingLeaf()` Retrieves the Clip node's application bounding leaf.
`Bounds` | `getApplicationBounds()` Retrieves the Clip node's application bounds.
`double` | `getBackDistance()` Retrieves the back clip distance.
`void` | `setApplicationBoundingLeaf(BoundingLeaf region)` Set the Clip's application region to the specified bounding leaf.
`void` | `setApplicationBounds(Bounds region)` Set the Clip's application region to the specified bounds.
`void` | `setBackDistance(double backDistance)` Sets the back clip distance to the specified value.
`void` | `updateNodeReferences(NodeReferenceTable referenceTable)` Callback used to allow a node to check if any scene graph objects referenced by that node have been duplicated via a call to `cloneTree`.

Methods inherited from class javax.media.j3d.Node
`cloneTree, cloneTree, cloneTree, getBounds, getBoundsAutoCompute, getCollidable, getLocalToVworld, getLocalToVworld, getParent, getPickable, setBounds, setBoundsAutoCompute, setCollidable, setPickable`

Methods inherited from class javax.media.j3d.SceneGraphObject
`clearCapability, duplicateSceneGraphObject, getCapability, getUserData, isCompiled, isLive, setCapability, setUserData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ALLOW_APPLICATION_BOUNDS_READ

    public static final int ALLOW_APPLICATION_BOUNDS_READ

  Specifies that the Clip allows read access to its application bounds and bounds leaf at runtime.

### ALLOW_APPLICATION_BOUNDS_WRITE

    public static final int ALLOW_APPLICATION_BOUNDS_WRITE

  Specifies that the Clip allows write access to its application bounds and bounds leaf at runtime.

### ALLOW_BACK_DISTANCE_READ

    public static final int ALLOW_BACK_DISTANCE_READ

  Specifies that the Clip allows read access to its back distance at runtime.

### ALLOW_BACK_DISTANCE_WRITE

    public static final int ALLOW_BACK_DISTANCE_WRITE

  Specifies that the Clip allows write access to its back distance at runtime.

Constructor Detail

### Clip

    public Clip()

  Constructs a Clip node with default parameters. The default values are as follows:
  back clip distance : 100
  scheduling bounds : null
  scheduling bounding leaf : null

### Clip

    public Clip(double backDistance)

  Constructs a Clip node with the specified back clip distance.

Method Detail

### setBackDistance

    public final void setBackDistance(double backDistance)

  Sets the back clip distance to the specified value. There are several considerations that need to be taken into account when choosing values for the front and back clip distances. These are enumerated in the description of View.setFrontClipDistance.
  Parameters:
    `backDistance` - the new back clip distance
  See Also:
    `View.setFrontClipDistance(double)`, `View.setBackClipDistance(double)`

### getBackDistance

    public final double getBackDistance()

  Retrieves the back clip distance.
  Returns:
    the current back clip distance

### setApplicationBounds

    public final void setApplicationBounds(Bounds region)

  Set the Clip's application region to the specified bounds. This is used when the application bounding leaf is set to null.
  Parameters:
    `region` - the bounds that contains the Clip's new application region.
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### getApplicationBounds

    public final Bounds getApplicationBounds()

  Retrieves the Clip node's application bounds.
  Returns:
    this Clip's application bounds information
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### setApplicationBoundingLeaf

    public final void setApplicationBoundingLeaf(BoundingLeaf region)

  Set the Clip's application region to the specified bounding leaf. When set to a value other than null, this overrides the application bounds object.
  Parameters:
    `region` - the bounding leaf node used to specify the Clip node's new application region.
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### getApplicationBoundingLeaf

    public final BoundingLeaf getApplicationBoundingLeaf()

  Retrieves the Clip node's application bounding leaf.
  Returns:
    this Clip's application bounding leaf information
  Throws:
    CapabilityNotSetException - if appropriate capability is not set and this object is part of live or compiled scene graph

### cloneNode

    public Node cloneNode(boolean forceDuplicate)

  Used to create a new instance of the node. This routine is called by `cloneTree` to duplicate the current node.
  Overrides:
    cloneNode in class Node
  Parameters:
    `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
  See Also:
    `Node.cloneTree()`, `Node.cloneNode(boolean)`, `Node.duplicateNode(javax.media.j3d.Node, boolean)`, `NodeComponent.setDuplicateOnCloneTree(boolean)`

### duplicateNode

    public void duplicateNode(Node originalNode,
                              boolean forceDuplicate)

  Copies all node information from `originalNode` into the current node. This method is called from the `cloneNode` method which is, in turn, called by the `cloneTree` method.

  For any NodeComponent objects contained by the object being duplicated, each NodeComponent object's `duplicateOnCloneTree` value is used to determine whether the NodeComponent should be duplicated in the new node or if just a reference to the current node should be placed in the new node. This flag can be overridden by setting the `forceDuplicate` parameter in the `cloneTree` method to `true`.

  Overrides:
    duplicateNode in class Node
  Parameters:
    `originalNode` - the original node to duplicate.
    `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
  See Also:
    `Node.cloneTree()`, `Node.cloneNode(boolean)`, `NodeComponent.setDuplicateOnCloneTree(boolean)`

### updateNodeReferences

    public void updateNodeReferences(NodeReferenceTable referenceTable)

  Callback used to allow a node to check if any scene graph objects referenced by that node have been duplicated via a call to `cloneTree`. This method is called by `cloneTree` after all nodes in the sub-graph have been duplicated. The cloned Leaf node's method will be called and the Leaf node can then look up any object references by using the `getNewObjectReference` method found in the `NodeReferenceTable` object. If a match is found, a reference to the corresponding object in the newly cloned sub-graph is returned. If no corresponding reference is found, either a DanglingReferenceException is thrown or a reference to the original object is returned depending on the value of the `allowDanglingReferences` parameter passed in the `cloneTree` call.
  Overrides:
    updateNodeReferences in class Leaf
  Parameters:
    `referenceTable` - a NodeReferenceTableObject that contains the `getNewObjectReference` method needed to search for new object instances.
  See Also:
    `NodeReferenceTable`, `Node.cloneTree()`, `DanglingReferenceException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD